//DESCRIPTION:Скрипт предназаначен для поиска последних строк абзаца с выравниванием 'Left Justified", у которых расстояние от последнего знака до правого края полосы меньше указанного значения. По умолчанию задается величина абзацного отступа. В таких абзацах это выравнивание заменяется на 'Full Justified'.
// CorrectionOfSomeLastLinesInParagraph.jsx
// InDesign CS3, CS4, CS5 JavaScript
//
// © Иванюшин М.Ю., 2011 ivanyushin#yandex.ru
// Скрипт предназаначен для поиска последних строк абзаца с выравниванием 'Left Justified", у которых расстояние от последнего знака до правого края полосы меньше указанного значения.
// По умолчанию задается величина абзацного отступа. В таких абзацах это выравнивание заменяется на 'Full Justified'.
//
//#target indesign
//#targetengine "session"
var myProgramName = "  Доведение неполных строк абзаца до формата полосы";
var myProgramDate ="  (28.04.2011)"
var myProgramTitul = myProgramName + myProgramDate ;

//--
// http://forums.adobe.com/message/3152162#3152162
var ProgressBar = function(/*str*/title)
{
     var w = new Window('palette', title, {x:0, y:0, width:440, height:60},{closeButton: false}),
          pb = w.add('progressbar', {x:20, y:32, width:400, height:12}, 0, 100),
          st = w.add('statictext', {x:20, y:12, width:400, height:20});
     st.justify = 'left';
     w.center();
     this.reset = function(msg,maxValue)
          {
          st.text = msg;
          pb.value = 0;
          pb.maxvalue = maxValue||0;
          pb.visible = !!maxValue;
          w.show();
          };
     this.hit = function() {++pb.value;};
     this.hide = function() {w.hide();};
     this.close = function() {w.close();};
}


LEFT_ALIGN =1818584692
LEFT_JUSTIFIED = 1818915700
FULLY_JUSTIFIED = 1718971500

// myInfoColorSample — шаблон цвета для myInfoColor
myInfoColorSample = [0, 100, 100, 0]; 

var mySelection = app.selection[0];
var myDocument = app.documents.item(0);
var myStory;
var myAppliedParagraphStyle;
var myFirstLineIndent;
var myRightPosition1;
var myRightPosition2;
var myMinValue;
var myBtnSel;
var myNameOfSelectedParagraph;
if(app.documents.length != 0) { // app.documents.length != 0
if(app.selection.length != 0) { // app.selection.length != 0
if (mySelection.constructor.name == "InsertionPoint") { // == "InsertionPoint"
myStory = mySelection.parentStory;
try{
	myColor = myDocument.colors.item("myInfoColor");
	myName = myColor.name;
    }
catch (myError) {
	myColor = myDocument.colors.add ({name:"myInfoColor", model:ColorModel.process, space:ColorSpace.CMYK, colorValue:myInfoColorSample});
    }
myFirstLineIndent = mySelection.paragraphs[0].firstLineIndent;
if (myFirstLineIndent == 0) {
	alert("Этот скрипт не работает с абзацами с нулевым абзацным отступом.",myProgramTitul);
	exit();	
	}
myNameOfSelectedParagraph = mySelection.appliedParagraphStyle.name;
var myCancelIsSelected = true; // это условие будет активно и при нажатии на красный крестик в правом верхнем окне меню
myWin = myDialog();
myWin.show();
if (myCancelIsSelected == true) exit(); // условие выполняется при нажатии на кнопку 'Cancel' и щелчке на красном крестике в правом верхнем окне меню
var pBar = new ProgressBar(myProgramTitul);
pBar.reset(" Минуточку... " , myStory.paragraphs.length);
var myNumberOfActions = 0;
for (i = 0; i < myStory.paragraphs.length; i++, pBar.hit()) { // myStory.paragraphs.length
	var myCurrParagraph = myStory.paragraphs[i];
	if (myBtnSel == true) { // обрабатывается только текст, абзацный стиль которого совпадает со стилем абзаца, в котором стоит курсор
		if (myCurrParagraph.appliedParagraphStyle.name != myNameOfSelectedParagraph) continue;
		} // обрабатывается только текст, абзацный стиль которого совпадает со стилем абзаца, в котором стоит курсор
	if (myCurrParagraph.justification != LEFT_JUSTIFIED) continue; 
	if (myCurrParagraph.lines.length == 1 || myCurrParagraph.lines[0].length == 0) { continue; } // проверка myCurrParagraph.lines[0].length == 0 обусловлена тем, что был тест, в котором длина строки была нулевой. В той строке был один символ с кодом 0x17 
	myAppliedParagraphStyle = myCurrParagraph.appliedParagraphStyle;	
	myFirstLineIndent = myAppliedParagraphStyle.firstLineIndent;
	if (myFirstLineIndent == 0) continue; // при обработке всей статьи встречен абзац с нулевым абзацным отступом
	var myTopLine = myCurrParagraph.lines[0];
	var myBottomLine = myCurrParagraph.lines[-1];
	myRightPosition1 = myTopLine.characters.lastItem().horizontalOffset;
	myRightPosition2 = myBottomLine.characters.lastItem().horizontalOffset;
	var myDiff = Math.abs(myRightPosition1 - myRightPosition2).toFixed(2);
	if ( (myDiff - myMinValue) < 0) {
		myCurrParagraph.justification = FULLY_JUSTIFIED;
		myCurrParagraph.fillColor = "myInfoColor";
		myNumberOfActions++;
	}
} // myStory.paragraphs.length
pBar.close(); 
if (myNumberOfActions == 0) {
	alert("Не найдено абзацев, требующих изменения форматирования.",myProgramTitul);
	exit();
	}
alert("Число обработанных абзацев " + myNumberOfActions + ".\nЭти абзацы с измененной выключкой отмечены цветом myInfoColor.",myProgramTitul);
exit();
} // == "InsertionPoint"
alert(" \nПоместите курсор в текст.\n",myProgramTitul);	
exit();
} // app.selection.length != 0
alert(" \nНичего не выбрано. Поместите курсор в текст и попробуйте снова.\n",myProgramTitul);	
exit();
} // app.documents.length != 0
alert(" \nНет открытых документов.\n",myProgramTitul);	
exit();
//////////
function myDialog() { // myDialog
var myWindow = new Window ("dialog", myProgramName);
myWindow.alignChildren = "left";
var myValueInfo = myWindow.add ("group");
myValueInfo.orientation = "row";
myValueInfo.add ("statictext", undefined, "Минимальный отступ справа последней абзацной строки, мм");
var myText = myValueInfo.add ("edittext", undefined, myFirstLineIndent);
myText.characters = 6;
var radio1 = myWindow.add ("radiobutton", undefined, "Обработать всю статью");
var radio2 = myWindow.add ("radiobutton", undefined, "Только абзацы со стилем параграфа, в котором стоит курсор");
radio2.value = true;
var myButtonGroup = myWindow.add ("panel");
myButtonGroup.orientation = "row";
myOKButon = myButtonGroup.add ("button", undefined, "OK");
myOKButon.graphics.font = "Tahoma:14";
myButtonGroup.add("statictext", {x:0, y:0, width:25, height:18}); // разделитель 
mySiteInfo = myButtonGroup.add("statictext", {x:0, y:0, width:135, height:18}, "http://adobeindesign.ru");
mySiteInfo.graphics.font = "Tahoma:12";
mySiteInfo.graphics.foregroundColor = mySiteInfo.graphics.newPen (mySiteInfo.graphics.PenType.SOLID_COLOR, [0, 0, 1, 1], 1);
myButtonGroup.add("statictext", {x:0, y:0, width:25, height:18}); // разделитель 
myCancelButon = myButtonGroup.add ("button", undefined, "Cancel");
myCancelButon.graphics.font = "Tahoma:14";
myWindow.addEventListener("mouseout", leaveTestPalette);
///------  
// http://forums.adobe.com/message/3462710#3462710
function leaveTestPalette(/*MouseEvent*/mev)
    {
    if( mev.target instanceof Window ) app.activate();
    }
///------
myCancelButon.onClick = function() { // myCancelButon.onClick  
myWindow.close();
myCancelIsSelected = true;
exit();
} // myCancelButon.onClick
myOKButon.onClick = function() { // myOKButon.onClick 
myMinValue = myText.text;
if (radio2.value == true) myBtnSel = true;
else myBtnSel = false;
myWindow.close();
myCancelIsSelected = false;
} // myOKButon.onClick
return myWindow;
} // myDialog





