//DESCRIPTION:Скрипт предназначен для запрета переноса последнего слова на развороте.
// LastWord_NOT_Hyphenated.jsx
// InDesign CS3, CS4, CS5 JavaScript
//
// © Иванюшин М.Ю., 2011
// Скрипт предназначен для управления переносом последнего слова на развороте.
// Идея скрипта — находить последнее слово и ставить перед ним символ нулевой ширины и дискреционный перенос.
// Символ нулевой ширины нужен, чтобы потом при помощи GREP-команды легко удалить этот знак переноса.
// Просто этот знак удалить нельзя, он мог быть поставлен во время верстки. 
// В обычном тексте перед ним могут быть как обычный, так и неразрывный пробелы, 
// теоретически возможно использование и других каких-то шпаций.
// Чтобы не связываться с лишними проверками, будем ставить два символа.
// Конечно, можно придумать GREP-команду, удаляющую дискреционный перенос, если перед ним стоит пробел, или неразрывный пробел, 
// это не вопрос. Но скрипт должен быть надежным, сделал его, отдал в пользование, и забыл. 
// И если учтешь и обычный пробел, и неразрывный, и тонкую шпацию, но какую-то из шпаций забудешь, 
// то это будет тонкая ошибка в работе программы.
// Решение ставить не один дискреционный перенос, а эту пару символов — более надежное решение.
//
// Если документ с установленной опцией Facing Pages, переносы на четных полосах не удаляются.
// 
// Расставленные таким способом запреты переносов устраняются пр помощи скрипта LastWord-Hyphenated.jsx.
//
// Текущая версия программы (дата последней модификации)
var myCurrentVersionData_xx_xx_xx = "27.05.11";
// myInfoColorSample — шаблон цвета для myInfoColor
myColorOfLastWordSample = [0, 100, 100, 0]; 
var myProgramTitul = " Управление переносом последнего слова " +"(" +myCurrentVersionData_xx_xx_xx +" )" ;
var myDocIsSpread = true;
var myVersion;
var myVerChar;

//--
// http://forums.adobe.com/message/3152162#3152162
var ProgressBar = function(title) {
     var w = new Window('palette', title, {x:0, y:0, width:440, height:60},{closeButton: false}),
          pb = w.add('progressbar', {x:20, y:32, width:400, height:12}, 0, 100),
          st = w.add('statictext', {x:20, y:12, width:400, height:20});
     st.justify = 'left';
     w.center();
     this.reset = function(msg,maxValue)
          {
          st.text = msg;
          pb.value = 0;
          pb.maxvalue = maxValue||0;
          pb.visible = !!maxValue;
          w.show();
          };
     this.hit = function() {++pb.value;};
     this.hide = function() {w.hide();};
     this.close = function() {w.close();};
} // ProgressBar
//--

function main() {
myVersion = app.scriptPreferences.version;
myVerChar = myVersion.charAt(0);
if (myVerChar < 5) {alert ("Скрипт не работает с этой версией программы."); exit();}	
var myDocument = app.documents[0];
myDescritinaryHyphen = "\u00AD";
myNonJoiner = "\u200C";
var myCurrPage, myNextPage;
var myPageOfLastWord, myPageOfNextWord;
//
if(app.documents.length != 0) { // app.documents.length != 0
	if(app.selection.length != 0){ // app.selection.length != 0
	var mySelection = app.selection[0];
	if(mySelection.constructor.name != "InsertionPoint") { // InsertionPoint
		alert("Перед запуском скрипта курсор должен быть в тексте. Ничего выделять не надо.", myProgramTitul);	
		exit(0);
		}  // InsertionPoint
	var myDoc = mySelection.parent.parent;
	var myDocPrefs = myDoc.documentPreferences;
	if (mySelection.parent.parent.documentPreferences.facingPages == false) { // это не разворот
		myDocIsSpread = false;
		} // это не разворот
	try{ 
		myColor = myDocument.colors.item("myColorOfLastWord");
		myName = myColor.name;
		} 
	catch (myError) { 
		myColor = myDocument.colors.add ({name:"myColorOfLastWord", model:ColorModel.process, space:ColorSpace.CMYK, colorValue:myColorOfLastWordSample});
		}
	myProcessingOfLastWord (mySelection.parentStory);
	exit(0);
	} // app.selection.length != 0   
else {
	alert("Не выбран текст для обработки.\nПоместите курсор в один из фреймов разворота и попробуйте снова.\n", myProgramTitul);	
	exit(0);
	} 
} // app.documents.length != 0
alert("Нет открытых документов.", myProgramTitul);	
exit();
} // main()

main();

////
function myProcessingOfLastWord (myStory) {
var myTextFrame;
var myNextTextFrame;
var myLine;
var myLastWord;
var myFound;
var myNextWord;
var myNmbrOfWords = 0;
var myInfoLine = "";

// Расстановка символов, запрещающих перенос в конце страницы.
if (myStory.overflows == true)  {  
	alert("В исходном файле есть переполнение текстовой цепочки.", myProgramTitul);	
	exit();
}
var pBar = new ProgressBar(myProgramTitul);
pBar.reset(" Ищем переносы в последних строках и запрещаем их... " , myStory.textColumns.length);
//цикл по числу колонок статьи. Движение сверху вниз
	for (myCounter = 0; myCounter < myStory.textColumns.length - 1; myCounter++, pBar.hit()) { // myCounter < myStory.textColumns.length
	// в цикле в условии окончания 'myStory.textColumns.length - 1' указана '-1', т.к. не надо анализировать перенос в последнем слове последнего фрейма.
	myCurrentColumn = myStory.textColumns[myCounter]; // ссылка на очередную колонку
	myNextColumn = myStory.textColumns[myCounter+1]; // ссылка на следующую  колонку 
	myPageOfCurrColumn = myGetPage(myCurrentColumn.parentTextFrames[0]);
	myPageOfNextColumn = myGetPage(myNextColumn.parentTextFrames[0]);
	if (myPageOfCurrColumn == myPageOfNextColumn) continue; // если колонки на одной странице, повторяем цикл
	if (myDocIsSpread == true) { // myDocIsSpread == true
		if (myPageOfCurrColumn % 2 == 0) { // == 0, если текстовый фрейм на четной, т.е. левой полосе
		continue;
		}  // == 0, если текстовый фрейм на четной, т.е. левой полосе
	} // myDocIsSpread == true
	// В случае многоколонника перед тем, как запрещать перенос последнего слова в колонке, надо убедиться, что это слово переносится.
	try { var myLastWordInCurrentColumn = myCurrentColumn.words[-1].contents; } // последнее слово в текущей колонке
	catch(e) { continue; }
	try { var myFirstWordInNextColumn = myNextColumn.words[0].contents;}  // первое слово в следующей колонке
	catch(e) { continue; }
	// если слово переносится, то myLastWordInCurrentColumn и myFirstWordInNextColumn совпадают. Критерий совпадения -- равенство индексов слов в статье.
	if (myStory.overflows == true)  {  
		pBar.close(); 
		alert("В процессе работы скрипта возникло переполнение текстовой цепочки.\nДобавьте фрейм в текстовую цепь и запустите скрипт еще раз.", myProgramTitul);	
		exit();
	}
	var myIndexOfLastWordInCurrentColumn = myCurrentColumn.words[-1].index;
	var myIndexOfFirstWordInNextColumn = myNextColumn.words[0].index;
	if (myIndexOfLastWordInCurrentColumn != myIndexOfFirstWordInNextColumn) continue;
	// Добавляем пару символов перед последним словом в колонке
		myCurrentColumn.words[-1].fillColor = "myColorOfLastWord"; 
		myCurrentColumn.words[-1].insertionPoints[0].contents = myNonJoiner + myDescritinaryHyphen;
		myNmbrOfWords++;
	} // myCounter < myStory.textColumns.length
	if (myNmbrOfWords != 0) { // myNmbrOfWords != 0
		myInfoLine += "Число обнаруженных переносов последнего слова — " + myNmbrOfWords  + ".\nТаких переносов в вёрстке больше нет. Слова, в которых запрещены переносы, отмечены цветом 'myColorOfLastWord'."; 
		var myHyphWord = new Array;	 
		var myNumberOfHyphWords = 0;	
		pBar.reset(" Проверка, не появились ли в результате обработки новые переносы... " , myStory.textColumns.length);
//цикл по числу колонок статьи. Движение сверху вниз
		for (myCounter = 0; myCounter < myStory.textColumns.length - 1; myCounter++, pBar.hit()) { // myCounter < myStory.textColumns.length
	// в цикле в условии окончания 'myStory.textColumns.length - 1' указана '-1', т.к. не надо анализировать перенос в последнем слове последнего фрейма.
			if (myStory.overflows == true)  {  
				pBar.close(); 
				alert("В процессе работы скрипта возникло переполнение текстовой цепочки.\nДобавьте фрейм в текстовую цепь и запустите скрипт еще раз.", myProgramTitul);	
				exit();
			}
			myCurrentColumn = myStory.textColumns[myCounter]; // ссылка на очередную колонку
			myNextColumn = myStory.textColumns[myCounter+1]; // ссылка на следующую  колонку 
			myPageOfCurrColumn = myGetPage(myCurrentColumn.parentTextFrames[0]);
			myPageOfNextColumn = myGetPage(myNextColumn.parentTextFrames[0]);
			if (myPageOfCurrColumn == myPageOfNextColumn) continue; // если колонки на одной странице, повторяем цикл
			if (myDocIsSpread == true) { // myDocIsSpread == true
				if (myPageOfCurrColumn % 2 == 0) { // == 0, если текстовый фрейм на четной, т.е. левой полосе
				continue;
				}  // == 0, если текстовый фрейм на четной, т.е. левой полосе
			} // myDocIsSpread == true
	// В случае многоколонника перед тем, как запрещать перенос последнего слова в колонке, надо убедиться, что это слово переносится.
			try { var myLastWordInCurrentColumn = myCurrentColumn.words[-1].contents;} // последнее слово в текущей колонке
			catch (e) { continue; }
			try { var myFirstWordInNextColumn = myNextColumn.words[0].contents; }  // первое слово в следующей колонке
			catch (e) { continue; }
	// если слово переносится, то myLastWordInCurrentColumn и myFirstWordInNextColumn совпадают. Критерий совпадения -- равенство индексов слов в статье.
			var myIndexOfLastWordInCurrentColumn = myCurrentColumn.words[-1].index;
			var myIndexOfFirstWordInNextColumn = myNextColumn.words[0].index;
			if (myIndexOfLastWordInCurrentColumn != myIndexOfFirstWordInNextColumn) continue;
			myHyphWord.push(myPageOfCurrColumn); // номер страницы с коротким последним словом в нижней строке помещен в массив myDash
			myNumberOfHyphWords++;
		} // myCounter < myStory.textColumns.length
		if (myNumberOfHyphWords !=0) { // myNumberOfHyphWords !=0
			var myPageNumbers  = myHyphWord.join (', ');	
			myInfoLine+="\rВ результате обработки появились новые переносы в последних словах, их число — " +  myNumberOfHyphWords + ".\rТребуют внимания страницы:  " +myPageNumbers + ".";
		} // myNumberOfHyphWords !=0
	}  // myNmbrOfWords != 0
	else myInfoLine += "Переносов последних слов не встречено.";
	pBar.close(); 
	alert(myInfoLine,myProgramTitul);
	exit(0);
} // myProcessingOfLastWord
///
function myGetNumberOfWordsInProcessedFrames(myText,myCount) {
// узнаем число слов в обработанных колонках	
var myWordCounter = 0;	
for (var i = 0; i < myCount; i++) {
	myWordCounter += myText.textColumns[i].words.length;
	}
return myWordCounter;
}	
///
function myGetPage(myTxtFrame) {
var myCntr = 0;	
var myParentTextFrame;
var myPage;
myParentTextFrame = myTxtFrame;
do {
		if (myCntr == 3) { // Число 3 никакого глубокого смысла не имеет. Оно взято просто с запасом, чтобы программно выйти из ситуации, если встретится случай, когда после трех итераций номер страницы не будет определен.
		alert ("Не удалось узнать номер страницы очередного фрейма.\nСкорее всего, он размещен на рабочем столе.");
		exit();
	}
	myCntr++;
	(myVerChar == 5 || myVersion == 6 ) ? myParentTextFrame = myParentTextFrame.parent  :  myParentTextFrame = myParentTextFrame.parentPage;	
	myPage = myParentTextFrame;
}
while ( myPage.constructor.name != "Page" )
return myPage.name;
} // function

